
import React, { useState, useEffect } from "react";
import Chart from 'react-apexcharts'

class ApexChart extends React.Component {
    constructor(props) {
      super(props);

      this.state = {
       
        series: [{
            name: "Attention Levels",
            data: this.props.series
        }],
        options: {
          chart: {
           
            type: 'line',
            zoom: {
              enabled: false
            }
          },
          dataLabels: {
            enabled: false
          },
          stroke: {
            curve: 'straight'
          },
          title: {
            text: 'Attention Levels',
            align: 'left'
          },
          grid: {
            row: {
              colors: ['#f3f3f3', 'transparent'], // takes an array which will be repeated on columns
              opacity: 0.5
            },
          },
          xaxis: {
            categories: [],
            labels: {
              show:false
            }
          }
        },
        
        zoom: {
          enabled: true,
          type: 'x',
          resetIcon: {
              offsetX: -10,
              offsetY: 0,
              fillColor: '#fff',
              strokeColor: '#37474F'
          },
          selection: {
              background: '#90CAF9',
              border: '#0D47A1'
          }    
      }
      
      };
    }

  

    render() {
      return (
        

  <div id="chart"  style={{width:"1500px",height:"500px",overfloxX:"scroll"}}>
      <Chart options={this.state.options} series={this.state.series} type="line"  style={{width:"500px",height:"500px",overfloxX:"scroll"}}/>
</div>


      );
    }
  }

  export default ApexChart;