import React, { useState, useEffect } from "react";
import socketIOClient from "socket.io-client";
import ApexChart from './ApexChart.js'

let ENDPOINT = "http://0.0.0.0:8080";
let globalArray=[];


export default class MotionDetectingClientClassComponent extends React.Component
{


    constructor(props) {
        super(props);
        this.state = {arrayValues: []};
      }

   componentDidMount() {
       console.log("New class component has been mounted")
        if(this.props.server===undefined)
            {
              console.log("No end point passed so using default end point = "+ENDPOINT)
            }
            else
            {
              ENDPOINT=this.props.server
              console.log("Using End point that is passed = "+ENDPOINT)
            }
            
        const socket = socketIOClient(ENDPOINT);
        /*socket.emit("message","TEST_MESSAGE");
        
        socket.on("FromAPI", data => {
          
          setResponse(data);
        });*/
    
      
    
        
      }


      shouldComponentUpdate() {
          console.log("did update called")
        const socket = socketIOClient(this.props.server);
        var localMediaStream = null;
        let video = document.querySelector("#videoElement");
        let canvas = document.querySelector("#canvasElement");
        let ctx = canvas.getContext('2d');
    
        function sendSnapshot() {
    
          // This is component did mount
         video = document.querySelector("#videoElement");
        
        
          if (!localMediaStream) {
            return;
          }
      
         ctx.drawImage(video, 0, 0, video.videoWidth, video.videoHeight, 0, 0, 300, 150);
      
          let dataURL = canvas.toDataURL('image/jpeg');
          
          socket.emit('input image', dataURL);
      
          socket.emit('output   ')
      
          //var img = new Image();
          socket.on('out-image-event',this.handler);
    
         
      
      
        }
        var constraints = {
          video: {
            width: { min: 640 },
            height: {  }
          }
        };
        navigator.mediaDevices.getUserMedia(constraints).then(function(stream) {
          video.srcObject = stream;
          localMediaStream = stream;
      
          setInterval(function () {
            sendSnapshot();
          }, 3000);
        }).catch(function(error) {
          console.log(error);
        });
    
        return () => {
          console.log("Executing socket.off")
          socket.off('out-image-event', (data)=> {
            console.log("MotionDetectingClientLog: you are moving a lot!");
            console.log(data);
            console.log("converting to number");
            //arrayValues.push(Number(data))
            globalArray.push(Number(data));
            //setArrayValues([...globalArray]);
            this.setState({arrayValues:globalArray})
          //  setArrayValues(array => {array.push(Number(data))});
            console.log(globalArray);
            if (this.props.callback === undefined) {
            }
            else {
              this.props.callback(data);
            }
          });
        }

      }

      render () {
        this.shouldComponentUpdate()
        return (
            <div style={{width:'100%',height:'60%'}}>  
              <video autoplay="true" id="videoElement" style={{width:'50%',height:'60%'}}></video>
              <canvas id="canvasElement" style={{display:'none'}}></canvas>
              <ApexChart id="chart" series={this.state.arrayValues}></ApexChart>
    
            </div>
      );
    
    }

     

   handler= (data)=> {
    console.log("MotionDetectingClientLog: you are moving a lot!");
    console.log(data);
    console.log("converting to number");
    //arrayValues.push(Number(data))
    globalArray.push(Number(data));
    //setArrayValues([...globalArray]);
    this.setState({arrayValues:globalArray})
  //  setArrayValues(array => {array.push(Number(data))});
    console.log(globalArray);
    if (this.props.callback === undefined) {
    }
    else {
      this.props.callback(data);
    }
  }





}




  

  

  


  




